# -*- coding: utf-8 -*-
#EWS - Großkämpfe



#### ISSUES ####

# only 2 armies yet ...

#### ISSUES ####




#### CONTROL PARAMETERS ####
biasfactor = 1.4
biasmultiplier = 4.0
biascutoff = 8
queuelength = 5
expfactor = 1/3.0
exp_logfactor = 1.5
atscatter = [2,1]
inactvalue = 0.7
woundvalue = 0.4
#### CONTROL PARAMETERS ####




#### IMPORTS ####

# for the fighting
from random import randrange as rnd
from random import shuffle
import math
# For selection of armies through command line arguments: 
import sys
# EWS standard dice
import pmw6

#### IMPORTS ####




#### WRAPPERS ####
def ews():
    return pmw6.pmw6()
#### WRAPPERS ####




#### CLASSES ####

class Army:

    def __init__(self,n=10,exp=0,weap=4,arm=2,resign=0.1,flee=0.3,name=u'unknown army'):
        # Form your lines!
        self.n = n
        self.ncurr = n
        self.exp = exp
        self.weap = weap
        self.arm = arm
        self.name = name
        self.soldiers = [Char(self.exp, self.weap, self.arm) for i in range(self.n)]
        self.active = [i for i in self.soldiers]
        self.wounded = []
        self.inactive = []
        self.dead = []
        self.resign = resign
        self.flee = flee

    def __repr__(self):
        # nice printout
        print self.name
        print '[' + `len(self.active)`+'/'+ `self.n` + ']'
        print 'Equipment', self.exp, self.weap, self.arm
        print '\n'
        for i in self.active:
            print i
        return ''

    def resumee(self):       
        print i.name + ': noch', `len(i.active)`, 'davon', `len(i.wounded)`, 'verwundet; zusätzlich', `len(i.inactive)`, 'kampfunfähig'

    def rearrange_lines(self):
        # statistics of outcome
        delseq = []
        for j in range(len(self.active)):
            if self.active[j].alive and self.active[j].queue:
                self.inactive.append(self.active[j])
                delseq.append(j)
            elif not self.active[j].alive:
                self.dead.append(self.active[j])
                delseq.append(j)
        delseq.sort()
        delseq.reverse()
        for j in delseq:
            del self.active[j]
        self.wounded = []
        for j in self.active:
            if j.wounds:
                self.wounded.append(j)
        inactseq = []
        for j in range(len(self.inactive)):
            self.inactive[j].queue -= 1
            if self.inactive[j].queue == 0:
                self.active.append(self.inactive[j])
                inactseq.append(j)
        inactseq.sort()
        inactseq.reverse()
        for j in inactseq:
            del self.inactive[j]
        shuffle(self.active)
        self.ges_exp = 0
        for j in self.active: 
            self.ges_exp += j.exp
        if verbose: 
            print 'Durchschnittliche Erfahrung:',self.ges_exp / max(len(self.active), 1)

    def count(self):
        self.nact = len(self.active)
        self.ninact = len(self.inactive)
        self.nwound = len(self.wounded)
        self.powerratio = float(self.nact + self.ninact * inactvalue + self.nwound * woundvalue) / self.n

    def fleeresigncheck(self):
        if self.powerratio < self.resign:
            print self.name, 'resigns'
            self.resumee()
            return 1
        elif self.powerratio < self.flee:
            print self.name, 'flees'
            self.resumee()
            return 1


class Char:

    def __init__(self,exp=0,weap=4,arm=2):
        # Raise your weapons!
        self.TP = 24 + 2 * exp
        self.WS = self.TP / 8
        self.HWS = self.TP / 2
        # HWS = WS * 3 = TP / 2
        # WS = TP / 6
        self.wounds = 0
        self.hwounds = 0
        self.dam = weap
        self.armor = arm
        self.attack = rnd(12-atscatter[0],13-atscatter[0]) + rnd(-atscatter[1],atscatter[1])
        self.exp = exp
        self.alive = True
        self.queue = 0

    def damage(self, tp, ws, hws):
        self.TP -= tp + (ws+3*hws)*self.WS
        self.wounds += ws
        self.hwounds += hws
        self.checkalive()

    def checkalive(self):
        self.alive = (self.TP > 0) and (self.hwounds < 2) and (self.wounds < 6)

    def __repr__(self):
        # nice printout
        print 'TP', self.TP
        print 'Wunden', self.wounds, self.hwounds
        print 'Aktiv', self.alive
        print 'Angriff', self.attack, 'Exp', self.exp
        return ''
    
#### CLASSES ####
        



#### FUNCTIONS ####
    
def battle(armies):
    # both armies do their best for 1 round

    # superior number check
    for i in armies:
        i.count()
        if i.nact == 0:
            return 'empty battle'
        if i.fleeresigncheck():
            return 'battle ended'
    if max(armies[0].nact, armies[1].nact) < 5: 
    	if armies[0].nact > armies[1].nact: 
		bias = int(round(3 * float(armies[0].nact - armies[1].nact)/armies[1].nact))
	else: 
		bias = 3 * float(armies[1].nact - armies[0].nact)/armies[0].nact
    else: 
    	q = math.log(float(armies[0].nact)/armies[1].nact,biasfactor)
    	# cutoff for high biases
    	bias = int(round(biasmultiplier * q/(1+abs(q)/biascutoff)))
    if verbose: 
        print 'Bias nach der Berechnung:', bias
    nr = min([armies[0].nact,armies[1].nact])
    
    # pair them
    [fight((armies[0].active[i],armies[1].active[i]), bias) for i in range(nr)]
    for i in armies:
        i.rearrange_lines()
    return False

        

def fight(chars, bias):
    # one pair of fighters
    # single Ein-Wurf-System fight

    # attack rolls
    for i in chars:
        wurf = ews()
        i.tmp = i.attack + i.dam + i.armor + int(round(5/3*i.exp)) + wurf - 3*i.wounds - 6*i.hwounds
	# Auswirkung von exp in Anfängerkämpfen
	# Nach dem ersten Kampf steigt die Kampffähigkeit direkt um eins. 
	# Die nächste Steigerung kommt nach dem vierten überlebtn Kampf. 
        if verbose: 
            print '\nCharakter',  i, 'würfelt', wurf, 'und kommt mit Schaden', i.dam, ', Rüstung', i.armor , 'Erfahrung', i.exp,'und seinen', i.wounds, 'Wunden und', i.hwounds ,'kritischen Wunden auf', i.tmp, '\n'

    # damage
    if verbose:
        print 'Ergebnis:', 'Char_1:', chars[0].tmp , '-', 'Char_2:', chars[1].tmp, '+', 'Bias:', bias, '\n', '  und Erfahrung Char_1:', chars[0].exp, 'Erfahrung Char_2:', chars[1].exp
    res = chars[0].tmp - chars[1].tmp + bias
    effect = int(math.floor(abs(res)/3))
    winner = max(3-effect,0)
    loser = max(3+effect,0)
    if verbose: 
        print 'Ergebnis:', res
        print 'Effekt:', effect
    if res > 0:
        chars[0].damage(0,winner,0)
        chars[1].damage(0,loser,0)
        chars[1].queue = loser * 2
    elif res < 0:
        chars[0].damage(0,loser,0)
        chars[1].damage(0,winner,0)
        chars[0].queue = loser * 2
    else:
        chars[0].damage(0,3,0)
        chars[1].damage(0,3,0)

    # experience
    chars[0].exp += max(math.log(max(chars[1].exp, 1), exp_logfactor), 1) * expfactor / max(chars[0].exp, 1)
    chars[1].exp += max(math.log(max(chars[0].exp, 1), exp_logfactor), 1) * expfactor / max(chars[1].exp, 1)
    for i in chars:
        if verbose: 
            print '\n', i
    if verbose: 
        print '\n\n'
        
#### FUNCTIONS ####




#### USER INPUT ####

# Config 1: 
# We're putting an army of average fighters against an army of very good fighters. 
# It is similar to a fight of newbies against veterans. 

verbose = False

try: 
    if sys.argv[2] == "verbose": 
        verbose = True
except: 
        verbose = False


try: 
    choice_of_army = sys.argv[1]
except: 
    choice_of_army = 'default'

if choice_of_army == "unbalanced": 
    Armies = [Army(1000, exp=0, weap=4, arm=2, name=u'Average Army'),
           Army(1000, exp=3, weap=4, arm=2, name=u'Veteran Army')]
           
    
# Config 2: 
# Now we're giving the Newbies superior arms and armor
# This is the equivalent of a newbie army with heavy axes and chainmail against an experienced army with rapiers and thin leather mail. 
# This evens the odds. 
elif choice_of_army == "balanced": 
    Armies = [Army(1000, exp=0, weap=5, arm=3, name=u'Rich Average Army'),
          Army(1000, exp=3, weap=3, arm=2, name=u'Poor Veteran Army')]
# Noch eine extrem disbalancierte Armeenkonstellation: 
elif choice_of_army == "Menschen_gegen_Monster": 
    Armies = [Army(60, exp=0, weap=4, arm=2, name=u'Menschen'),
          Army(26, exp=6, weap=4, arm=2, name=u'Monster')] # => Fert ~ 18, TP ~ 26, WS ~ 6
# Eine noch extremer disbalancierte Armeenkonstellation: 
elif choice_of_army == "Menschen_gegen_Legenden": 
    Armies = [Army(60, exp=0, weap=4, arm=2, name=u'Menschen'),
          Army(10, exp=12, weap=4, arm=2, name=u'Legenden')] # => Fert ~ 24, TP ~48, WS ~ 8
# Und noch schlimmer (Eine Kategorie unterschied): 
elif choice_of_army == "Menschen_gegen_Halbgoetter": 
    Armies = [Army(180, exp=0, weap=4, arm=2, name=u'Menschen'),
          Army(3, exp=24, weap=4, arm=2, name=u'Halbgötter')] # => Fert ~ 36, TP ~72, WS ~ 12
# Und schlussendlich (Kategorie 4 (Menschen) gegen Kategorie 6 (Riesen und größere): 
elif choice_of_army == "Menschen_gegen_Riesen": 
    Armies = [Army(10000, exp=0, weap=4, arm=2, name=u'Menschen'),
          Army(2, exp=48, weap=4, arm=2, name=u'Riesen')] # => Fert ~ 60, TP ~120, WS ~ 20
	
# Als interessante Versuch füregn wir 4 Menschen gegen eine Leeegnnd hizu: 
elif choice_of_army == "Vier_Menschen_gegen_eine_Legende":
    Armies = [Army(4, exp=0, weap=4, arm=2, name=u'Menschen'),
              Army(1, exp=12, weap=4, arm=2, name=u'Legende')] # => Fert ~ 24, TP ~48, WS ~ 8

# Als interessante Versuch füregn wir 4 Menschen gegen eine Leeegnnd hizu:
elif choice_of_army == "Fuenf_Menschen_gegen_eine_Legende":
    Armies = [Army(5, exp=0, weap=4, arm=2, name=u'Menschen'),
                  Army(1, exp=12, weap=4, arm=2, name=u'Legende')] # => Fert ~ 24, TP ~48, WS ~ 8
# Und jetzt noch die einfache unfiare Situation: Drei gegen Zwei
elif choice_of_army == "Drei_gegen_Zwei": 
    Armies = [Army(3, exp=0, weap=4, arm=2, name=u'Standard Armee 1'),
              Army(2, exp=0, weap=4, arm=2, name=u'Standard Armee 2')]


else: 
    Armies = [Army(10000, exp=0, weap=4, arm=2, name=u'Standard Armee 1'),
          Army(10000, exp=0, weap=4, arm=2, name=u'Standard Armee 2')]




#### USER INPUT ####




#### SELF-CHECK ####
    
if __name__ == '__main__':
    rounds = 0
    while not battle(Armies):
        rounds += 1
        print rounds, 'Runde(n)'
        for i in Armies:
            i.resumee()
        
#### SELF-CHECK ####
